/**
*	w5100.h
*	W5100hCo	wb_
*	Copyright (c)Junnichi Tomaru
*/

#ifndef	_W5100_DEFINED_
#define	_W5100_DEFINED_

#include	"userdef.h"

struct	INFO_T{			/* \Pbg */
	byte	status;		/*  */
	word	txmask;		/* Mobt@}XN */
	word	rxmask;		/* Mobt@}XN */
	word	txsize;		/* Mobt@TCY */
	word	rxsize;		/* Mobt@TCY */
	word	txbufbaseaddr;	/* Mobt@x[XAhX */
	word	rxbufbaseaddr;	/* Mobt@x[XAhX */
};
typedef	struct INFO_T	info_t;

#define	MAX_SOCKET	4	/* ő\Pbg */

/* ---------- oX[hI ---------- */
/**//*#define	DIRECT_BUS */
/**//*#define	INDIRECT_BUS */
#define	SPI_BUS

/* ---------- `֌W ---------- */
#define	MAP_BASE	0x8000
#if defined( DIRECT_BUS )
#define	COMMON_BASE	MAP_BASE
#define	POINT		*(volatile byte*)
#else
#define	COMMON_BASE	0x0000
#define	POINT
#endif

/* ---------- SPIR}h ---------- */
#define	SPI_WRITE	0xf0
#define	SPI_READ	0x0f
#define	SPI_DUMMY	0

/* ---------- W5100 ---------- */
#define	W5100_TXBUF	0x4000	/* Mobt@JnAhX */
#define	W5100_RXBUF	0x6000	/* Mobt@JnAhX */

/* ---------- C_CNg[hpWX^ ---------- */
#define	IDM_OR	(POINT(MAP_BASE + 0x0000))
#define	IDM_AR0	(POINT(MAP_BASE + 0x0001))
#define	IDM_AR1	(POINT(MAP_BASE + 0x0002))
#define	IDM_DR	(POINT(MAP_BASE + 0x0003))

/* ---------- ʃWX^ ---------- */
#define	MR	(POINT(COMMON_BASE + 0x0000))	/* [hWX^ */
#define	GAR0	(POINT(COMMON_BASE + 0x0001))	/* Q[gEFCAhX */
#define	GAR1	(POINT(COMMON_BASE + 0x0002))
#define	GAR2	(POINT(COMMON_BASE + 0x0003))
#define	GAR3	(POINT(COMMON_BASE + 0x0004))
#define	SUBR0	(POINT(COMMON_BASE + 0x0005))	/* Tulbg}XN */
#define	SUBR1	(POINT(COMMON_BASE + 0x0006))
#define	SUBR2	(POINT(COMMON_BASE + 0x0007))
#define	SUBR3	(POINT(COMMON_BASE + 0x0008))
#define	SHAR0	(POINT(COMMON_BASE + 0x0009))	/* MACAhX */
#define	SHAR1	(POINT(COMMON_BASE + 0x000A))
#define	SHAR2	(POINT(COMMON_BASE + 0x000B))
#define	SHAR3	(POINT(COMMON_BASE + 0x000C))
#define	SHAR4	(POINT(COMMON_BASE + 0x000D))
#define	SHAR5	(POINT(COMMON_BASE + 0x000E))
#define	SIPR0	(POINT(COMMON_BASE + 0x000F))	/* IPAhX */
#define	SIPR1	(POINT(COMMON_BASE + 0x0010))
#define	SIPR2	(POINT(COMMON_BASE + 0x0011))
#define	SIPR3	(POINT(COMMON_BASE + 0x0012))
/* 0x13, 0x14 reserved */
#define	IR	(POINT(COMMON_BASE + 0x0015))	/* 荞݃WX^ */
#define	IMR	(POINT(COMMON_BASE + 0x0016))	/* 荞݃}XNWX^ */
#define	RTR0	(POINT(COMMON_BASE + 0x0017))	/* ^CAEgWX^AhX */
#define	RTR1	(POINT(COMMON_BASE + 0x0018))
#define	RCR	(POINT(COMMON_BASE + 0x0019))	/* gCWX^ */
#define	RMSR	(POINT(COMMON_BASE + 0x001A))	/* MTCYWX^ */
#define	TMSR	(POINT(COMMON_BASE + 0x001B))	/* MTCYWX^ */
#define	PATR0	(POINT(COMMON_BASE + 0x001C))	/* PPPoE[h̔F؃^Cv */
/* #define PPPALGO (COMMON_BASE + 0x001D) */
#define	PTIMER	(POINT(COMMON_BASE + 0x0028))
#define	PMAGIC	(POINT(COMMON_BASE + 0x0029))

#define	UIPR0	(POINT(COMMON_BASE + 0x002A))	/* 񓞒BIPAhX */
#define	UIPR1	(POINT(COMMON_BASE + 0x002B))
#define	UIPR2	(POINT(COMMON_BASE + 0x002C))
#define	UIPR3	(POINT(COMMON_BASE + 0x002D))
#define	UPORT0	(POINT(COMMON_BASE + 0x002E))	/* 񓞒B|[gԍ */
#define	UPORT1	(POINT(COMMON_BASE + 0x002F))

/* ---------- \PbgWX^O ---------- */
#define	S0_BASE	0x0400
#define	S0_MR		(POINT(S0_BASE + 0x0000))	/* [hWX^ */
#define	S0_CR		(POINT(S0_BASE + 0x0001))	/* R}hWX^ */
#define	S0_IR		(POINT(S0_BASE + 0x0002))	/* 荞݃WX^ */
#define	S0_SR		(POINT(S0_BASE + 0x0003))	/* Xe[^XWX^ */
#define	S0_PORT0	(POINT(S0_BASE + 0x0004))	/* |[g */
#define	S0_PORT1	(POINT(S0_BASE + 0x0005))
#define	S0_DHAR0	(POINT(S0_BASE + 0x0006))	/* ʐMMACAhX */
#define	S0_DHAR1	(POINT(S0_BASE + 0x0007))
#define	S0_DHAR2	(POINT(S0_BASE + 0x0008))
#define	S0_DHAR3	(POINT(S0_BASE + 0x0009))
#define	S0_DHAR4	(POINT(S0_BASE + 0x000A))
#define	S0_DHAR5	(POINT(S0_BASE + 0x000B))
#define	S0_DIPR0	(POINT(S0_BASE + 0x000C))	/* ʐM̂hoAhX */
#define	S0_DIPR1	(POINT(S0_BASE + 0x000D))
#define	S0_DIPR2	(POINT(S0_BASE + 0x000E))
#define	S0_DIPR3	(POINT(S0_BASE + 0x000F))
#define	S0_DPORT0	(POINT(S0_BASE + 0x0010))	/* ʐM̃|[g */
#define	S0_DPORT1	(POINT(S0_BASE + 0x0011))
#define	S0_MSSR0	(POINT(S0_BASE + 0x0012))	/* Maximum Segment Size(MSS) */
#define	S0_MSSR1	(POINT(S0_BASE + 0x0013))
#define	S0_PROTO	(POINT(S0_BASE + 0x0014))	/* IP RAW[h̃vgRԍ */
#define	S0_TOS		(POINT(S0_BASE + 0x0015))	/* TOS(Type Of servise) */
#define	S0_TTL		(POINT(S0_BASE + 0x0016))	/* TTL(Time to live) */
#define	S0_TX_FSR0	(POINT(S0_BASE + 0x0020))	/* Tx free size */
#define	S0_TX_FSR1	(POINT(S0_BASE + 0x0021))
#define	S0_TX_RD0	(POINT(S0_BASE + 0x0022))	/* Tx read pointer */
#define	S0_TX_RD1	(POINT(S0_BASE + 0x0023))
#define	S0_TX_WR0	(POINT(S0_BASE + 0x0024))	/* Tx write pointer */
#define	S0_TX_WR1	(POINT(S0_BASE + 0x0025))
#define	S0_RX_RSR0	(POINT(S0_BASE + 0x0026))	/* Received data size */
#define	S0_RX_RSR1	(POINT(S0_BASE + 0x0027))
#define	S0_RX_RD0	(POINT(S0_BASE + 0x0028))	/* Read point of Receive memory */
#define	S0_RX_RD1	(POINT(S0_BASE + 0x0029))
#define	S0_RX_WR0	(POINT(S0_BASE + 0x002A))	/* Write point of Receive memory */
#define	S0_RX_WR1	(POINT(S0_BASE + 0x002B))

/* \PbgWX^P */
#define	S1_BASE	0x0500
#define	S1_MR		(POINT(S1_BASE + 0x0000))
#define	S1_CR		(POINT(S1_BASE + 0x0001))
#define	S1_IR		(POINT(S1_BASE + 0x0002))
#define	S1_SR		(POINT(S1_BASE + 0x0003))
#define	S1_PORT0	(POINT(S1_BASE + 0x0004))
#define	S1_PORT1	(POINT(S1_BASE + 0x0005))
#define	S1_DHAR0	(POINT(S1_BASE + 0x0006))
#define	S1_DHAR1	(POINT(S1_BASE + 0x0007))
#define	S1_DHAR2	(POINT(S1_BASE + 0x0008))
#define	S1_DHAR3	(POINT(S1_BASE + 0x0009))
#define	S1_DHAR4	(POINT(S1_BASE + 0x000A))
#define	S1_DHAR5	(POINT(S1_BASE + 0x000B))
#define	S1_DIPR0	(POINT(S1_BASE + 0x000C))
#define	S1_DIPR1	(POINT(S1_BASE + 0x000D))
#define	S1_DIPR2	(POINT(S1_BASE + 0x000E))
#define	S1_DIPR3	(POINT(S1_BASE + 0x000F))
#define	S1_DPORT0	(POINT(S1_BASE + 0x0010))
#define	S1_DPORT1	(POINT(S1_BASE + 0x0011))
#define	S1_MSSR0	(POINT(S1_BASE + 0x0012))
#define	S1_MSSR1	(POINT(S1_BASE + 0x0013))
#define	S1_PROTO	(POINT(S1_BASE + 0x0014))
#define	S1_TOS		(POINT(S1_BASE + 0x0015))
#define	S1_TTL		(POINT(S1_BASE + 0x0016))
#define	S1_TX_FSR0	(POINT(S1_BASE + 0x0020))
#define	S1_TX_FSR1	(POINT(S1_BASE + 0x0021))
#define	S1_TX_RD0	(POINT(S1_BASE + 0x0022))
#define	S1_TX_RD1	(POINT(S1_BASE + 0x0023))
#define	S1_TX_WR0	(POINT(S1_BASE + 0x0024))
#define	S1_TX_WR1	(POINT(S1_BASE + 0x0025))
#define	S1_RX_RSR0	(POINT(S1_BASE + 0x0026))
#define	S1_RX_RSR1	(POINT(S1_BASE + 0x0027))
#define	S1_RX_RD0	(POINT(S1_BASE + 0x0028))
#define	S1_RX_RD1	(POINT(S1_BASE + 0x0029))
#define	S1_RX_WR0	(POINT(S1_BASE + 0x002A))
#define	S1_RX_WR1	(POINT(S1_BASE + 0x002B))

/* \PbgWX^Q */
#define	S2_BASE	0x0600
#define	S2_MR		(POINT(S2_BASE + 0x0000))
#define	S2_CR		(POINT(S2_BASE + 0x0001))
#define	S2_IR		(POINT(S2_BASE + 0x0002))
#define	S2_SR		(POINT(S2_BASE + 0x0003))
#define	S2_PORT0	(POINT(S2_BASE + 0x0004))
#define	S2_PORT1	(POINT(S2_BASE + 0x0005))
#define	S2_DHAR0	(POINT(S2_BASE + 0x0006))
#define	S2_DHAR1	(POINT(S2_BASE + 0x0007))
#define	S2_DHAR2	(POINT(S2_BASE + 0x0008))
#define	S2_DHAR3	(POINT(S2_BASE + 0x0009))
#define	S2_DHAR4	(POINT(S2_BASE + 0x000A))
#define	S2_DHAR5	(POINT(S2_BASE + 0x000B))
#define	S2_DIPR0	(POINT(S2_BASE + 0x000C))
#define	S2_DIPR1	(POINT(S2_BASE + 0x000D))
#define	S2_DIPR2	(POINT(S2_BASE + 0x000E))
#define	S2_DIPR3	(POINT(S2_BASE + 0x000F))
#define	S2_DPORT0	(POINT(S2_BASE + 0x0010))
#define	S2_DPORT1	(POINT(S2_BASE + 0x0011))
#define	S2_MSSR0	(POINT(S2_BASE + 0x0012))
#define	S2_MSSR1	(POINT(S2_BASE + 0x0013))
#define	S2_PROTO	(POINT(S2_BASE + 0x0014))
#define	S2_TOS		(POINT(S2_BASE + 0x0015))
#define	S2_TTL		(POINT(S2_BASE + 0x0016))
#define	S2_TX_FSR0	(POINT(S2_BASE + 0x0020))
#define	S2_TX_FSR1	(POINT(S2_BASE + 0x0021))
#define	S2_TX_RD0	(POINT(S2_BASE + 0x0022))
#define	S2_TX_RD1	(POINT(S2_BASE + 0x0023))
#define	S2_TX_WR0	(POINT(S2_BASE + 0x0024))
#define	S2_TX_WR1	(POINT(S2_BASE + 0x0025))
#define	S2_RX_RSR0	(POINT(S2_BASE + 0x0026))
#define	S2_RX_RSR1	(POINT(S2_BASE + 0x0027))
#define	S2_RX_RD0	(POINT(S2_BASE + 0x0028))
#define	S2_RX_RD1	(POINT(S2_BASE + 0x0029))
#define	S2_RX_WR0	(POINT(S2_BASE + 0x002A))
#define	S2_RX_WR1	(POINT(S2_BASE + 0x002B))

/* \PbgWX^R */
#define	S3_BASE	0x0700
#define	S3_MR		(POINT(S3_BASE + 0x0000))
#define	S3_CR		(POINT(S3_BASE + 0x0001))
#define	S3_IR		(POINT(S3_BASE + 0x0002))
#define	S3_SR		(POINT(S3_BASE + 0x0003))
#define	S3_PORT0	(POINT(S3_BASE + 0x0004))
#define	S3_PORT1	(POINT(S3_BASE + 0x0005))
#define	S3_DHAR0	(POINT(S3_BASE + 0x0006))
#define	S3_DHAR1	(POINT(S3_BASE + 0x0007))
#define	S3_DHAR2	(POINT(S3_BASE + 0x0008))
#define	S3_DHAR3	(POINT(S3_BASE + 0x0009))
#define	S3_DHAR4	(POINT(S3_BASE + 0x000A))
#define	S3_DHAR5	(POINT(S3_BASE + 0x000B))
#define	S3_DIPR0	(POINT(S3_BASE + 0x000C))
#define	S3_DIPR1	(POINT(S3_BASE + 0x000D))
#define	S3_DIPR2	(POINT(S3_BASE + 0x000E))
#define	S3_DIPR3	(POINT(S3_BASE + 0x000F))
#define	S3_DPORT0	(POINT(S3_BASE + 0x0010))
#define	S3_DPORT1	(POINT(S3_BASE + 0x0011))
#define	S3_MSSR0	(POINT(S3_BASE + 0x0012))
#define	S3_MSSR1	(POINT(S3_BASE + 0x0013))
#define	S3_PROTO	(POINT(S3_BASE + 0x0014))
#define	S3_TOS		(POINT(S3_BASE + 0x0015))
#define	S3_TTL		(POINT(S3_BASE + 0x0016))
#define	S3_TX_FSR0	(POINT(S3_BASE + 0x0020))
#define	S3_TX_FSR1	(POINT(S3_BASE + 0x0021))
#define	S3_TX_RD0	(POINT(S3_BASE + 0x0022))
#define	S3_TX_RD1	(POINT(S3_BASE + 0x0023))
#define	S3_TX_WR0	(POINT(S3_BASE + 0x0024))
#define	S3_TX_WR1	(POINT(S3_BASE + 0x0025))
#define	S3_RX_RSR0	(POINT(S3_BASE + 0x0026))
#define	S3_RX_RSR1	(POINT(S3_BASE + 0x0027))
#define	S3_RX_RD0	(POINT(S3_BASE + 0x0028))
#define	S3_RX_RD1	(POINT(S3_BASE + 0x0029))
#define	S3_RX_WR0	(POINT(S3_BASE + 0x002A))
#define	S3_RX_WR1	(POINT(S3_BASE + 0x002B))

/* [hWX^rbg */
#define	MR_RST		0x80	/* Zbg */
#define	MR_PB		0x10	/* pingubN[h */
#define	MR_PPPOE	0x08	/* PPPoE */
#define	MR_LB		0x04	/* GfBAZNg(indirect mode) */
#define	MR_AI		0x02	/* I[gCNg(indirect mode) */
#define	MR_IND		0x01	/* C_CNg[h */

/* IRWX^rbg */
#define	IR_CONFLICT	0x80	/* IPAhXՓ */
#define	IR_UNREACH	0x40	/* UDPMɂsB */
#define	IR_PPPoE	0x20	/* PPPoEN[Y */
#define	IR_SOCK0	0x01	/* \Pbg荞 */
#define	IR_SOCK1	0x02
#define	IR_SOCK2	0x04
#define	IR_SOCK3	0x08

/* Sn_MRWX^ */
#define	Sn_MR_CLOSE	0x00	/* \PbgN[Y */
#define	Sn_MR_TCP	0x01	/* TCPgp */
#define	Sn_MR_UDP	0x02	/* UDPgp */
#define	Sn_MR_IPRAW	0x03	/* lbg[Nwx̒ʐM */
#define	Sn_MR_MACRAW	0x04	/* f[^Nwx */
#define	Sn_MR_PPPOE	0x05	/* PPPoE */
#define	Sn_MR_ND	0x20	/* No Delayed Ack(TCP) */
#define	Sn_MR_MULTI	0x80	/* }`LXg */

/* Sn_CRWX^ */
#define	Sn_CR_OPEN	0x01	/* \Pbg̃I[v^ */
#define	Sn_CR_LISTEN	0x02	/* NCAg̐ڑ҂(TCP T[o[h) */
#define	Sn_CR_CONNECT	0x04	/* T[oւ̐ڑ(TCP NCAg[h) */
#define	Sn_CR_DISCON	0x08	/* T[o̐ؒf(TCP) */
#define	Sn_CR_CLOSE	0x10	/* \Pbg̃N[Y */
#define	Sn_CR_SEND	0x20	/* f[^M(M|C^XV) */
#define	Sn_CR_SEND_MAC	0x21	/* ARPŉMACAhXtŃf[^M */
#define	Sn_CR_SEND_KEEP	0x22	/* L[vACubZ[WM(TCP) */
#define	Sn_CR_RECV	0x40	/* f[^M(M|C^XV) */

#define	Sn_CR_PCON	0x23	/* PPPoE */
#define	Sn_CR_PDISCON	0x24	
#define	Sn_CR_PCR	0x25	
#define	Sn_CR_PCN	0x26	
#define	Sn_CR_PCJ	0x27	

/* Sn_IRWX^ */
#define	Sn_IR_PRECV	0x80	
#define	Sn_IR_PFAIL	0x40	
#define	Sn_IR_PNEXT	0x20	

#define	Sn_IR_SEND_OK	0x10	/* M */
#define	Sn_IR_TIMEOUT	0x08	/* ^CAEg */
#define	Sn_IR_RECV	0x04	/* f[^M */
#define	Sn_IR_DISCON	0x02	/* RlNVN[Y */
#define	Sn_IR_CON	0x01	/* RlNV */

/* Sn_SRWX^ */
#define	SOCK_CLOSED	0x00	/* N[Y */
#define	SOCK_INIT 	0x13	/* TCP  */
#define	SOCK_LISTEN	0x14	/* TCP LISTEN */
#define	SOCK_SYNSENT	0x15	/* TCP SYNM */
#define	SOCK_SYNRECV	0x16	/* TCP SYNM */
#define	SOCK_ESTABLISHED	0x17	/* TCP RlNV */
#define	SOCK_FIN_WAIT	0x18	/* N[Y(SOCK_CLOSED) */
#define	SOCK_CLOSING	0x1A	/* N[Y(SOCK_CLOSED) */
#define	SOCK_TIME_WAIT	0x1B	/* N[Y(SOCK_CLOSED) */
#define	SOCK_CLOSE_WAIT	0x1C	/* N[Y(SOCK_CLOSED) */
#define	SOCK_LAST_ACK	0x1D	/* N[Y(SOCK_CLOSED) */
#define	SOCK_UDP	0x22	/* UDPgp */
#define	SOCK_IPRAW	0x32	/* IPraw[hgp */
#define	SOCK_MACRAW	0x42	/* MACraw[hgp */
#define	SOCK_PPPOE	0x5F	/* PPPoE[hgp */

/* Mobt@TCY */
#define	MEM_CH0_1K	0x00
#define	MEM_CH0_2K	0x01
#define	MEM_CH0_4K	0x02
#define	MEM_CH0_8K	0x03
#define	MEM_CH1_1K	0x00
#define	MEM_CH1_2K	0x04
#define	MEM_CH1_4K	0x08
#define	MEM_CH1_8K	0x0c
#define	MEM_CH2_1K	0x00
#define	MEM_CH2_2K	0x10
#define	MEM_CH2_4K	0x20
#define	MEM_CH2_8K	0x30
#define	MEM_CH3_1K	0x00
#define	MEM_CH3_2K	0x40
#define	MEM_CH3_4K	0x80
#define	MEM_CH3_8K	0xc0

info_t	socksts[MAX_SOCKET];	/* e\Pbg */

/* ---------- {IʐM ---------- */
byte	spiseq( char data );
void	w5100_write( word addr, byte data );
byte	w5100_read( word addr );
void	w5100_writebuf( word addr, byte *buf, word len );
void	w5100_readbuf( word addr, byte *buf, word len );

/* ---------- ʃWX^ ---------- */
void	set_interrupt( byte data );
byte	get_interrupt( void );
void	set_intmask( byte mask );
byte	get_intmask( void );
void	set_retrytime( word timeout );
word	get_retrytime( void );
void	set_retrycnt( byte retry );
byte	get_retrycnt( void );
void	set_srcipaddr( dword addr );
dword	get_srcipaddr( void );
void	set_netmask( dword addr );
dword	get_netmask( void );
void	set_gateway( dword addr );
dword	get_gateway( void );
void	set_macaddress( byte *addr );
void	get_macaddress( byte *addr );

/* ---------- \Pbgʑ ---------- */
void	setsn_mr( char sn, byte val );
byte	getsn_mr( char sn );
void	setsn_cr( char sn, byte val );
byte	getsn_cr( char sn );
void	setsn_ir( char sn, byte val );
byte	getsn_ir( char sn );
byte	getsn_sr( char sn );

void	setsn_srcport( char sn, word port );
word	getsn_srcport( char sn );
void	setsn_destmac( char sn, byte *addr );
void	getsn_destmac( char sn, byte *addr );
void	setsn_destip( char sn, dword addr );
dword	getsn_destip( char sn );
void	setsn_destport( char sn, word port );
word	getsn_destport( char sn );
void	setsn_mss( char sn, word mss );
word	getsn_mss( char sn );
void	setsn_ttl( char sn, byte val );
byte	getsn_ttl( char sn );
void	setsn_proto( char n, byte proto );
byte	getsn_proto( char sn );
word	getsn_tx_fsr( char sn );
word	getsn_rx_rsr( char sn );
void	setsn_rx_rd( char sn, word pnt );
word	getsn_rx_rd( char sn );
void	send_data( char sn, byte *data, word len );
void	recv_data( char sn, byte *data, word len );
void	write_data( char sn, byte *src, word dst, word len );
byte	*read_data( char sn, word src, byte *dst, word len );

/* ----------  ---------- */
void	w5100_init( void );
void	w5100_meminit( byte tx_size, byte rx_size );

#endif
